﻿using LawFirmContracts.BindingModels;
using LawFirmContracts.ViewModels;
using LawFirmDataModels.Enums;
using LawFirmDataModels.Models;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace LawFirmListImplements.Models
{
    public class Order : IOrderModel
    {
        public int DocumentId { get; private set; }

        public string DocumentName { get; private set; } = string.Empty;

        public int Count { get; private set; }

        public double Sum { get; private set; }

        public OrderStatus Status { get; private set; } = OrderStatus.Неизвестен;

        public DateTime DateCreate { get; private set; } = DateTime.Now;

        public DateTime? DateImplement { get; private set; }

        public int Id { get; private set; }

        public static Order? Create(OrderBindingModel? model)
        {
            if (model == null)
            {
                return null;
            }
            return new Order
            {
                DocumentId = model.DocumentId,
                DocumentName = model.DocumentName,
                Count = model.Count,
                Sum = model.Sum,
                Status = model.Status,
                DateCreate = model.DateCreate,
                DateImplement = model.DateImplement,
                Id = model.Id,
            };
        }

        public void Update(OrderBindingModel? model)
        {
            if (model == null)
            {
                return;
            }
            DocumentId = model.DocumentId;
            DocumentName = model.DocumentName;
            Count = model.Count;
            Sum = model.Sum;
            Status = model.Status;
            DateCreate = model.DateCreate;
            DateImplement = model.DateImplement;
            Id = model.Id;
        }

        public OrderViewModel GetViewModel => new()
        {
            DocumentId = DocumentId,
            DocumentName = DocumentName,
            Count = Count,
            Sum = Sum,
            DateCreate = DateCreate,
            DateImplement= DateImplement,
            Id = Id,
            Status= Status,
        };
    }
}
